/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include "VDDialogue.h"



/* **********************************************************************************************************************
   Constructor
   -----------
   #param  theID    ID of the dialogue
   #param  theText  Text of the dialogue
   **********************************************************************************************************************/

VDDialogue::VDDialogue(int theID, LPCSTR theText) {
    text = VDText(theID, theText);
};



/* **********************************************************************************************************************
   Destructor
   **********************************************************************************************************************/

VDDialogue::~VDDialogue() {
};



/* **********************************************************************************************************************
   AddOption
   ---------
   Adds an option that the user can use to respond to the dialogue.
   #param  text    Text of the option.
   #param  nextID  ID of the next dialogue that choosing the option results in.
   **********************************************************************************************************************/

void VDDialogue::AddOption(LPCSTR text, int nextID) {
    VDText newOption = VDText(text, nextID);
    options.push_back(newOption);
};



/* **********************************************************************************************************************
   Accessors and Modifiers
   **********************************************************************************************************************/

LPCSTR VDDialogue::GetText() {
    return text.GetText();
};

void VDDialogue::SetText(LPCSTR theText) {
    text.SetText(theText);
};

int VDDialogue::GetID() {
    return text.GetID();
};

list<VDText> VDDialogue::GetOptions() {
    return options;
};