/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include "VDEntity.h"



/* **********************************************************************************************************************
   Constructor
   **********************************************************************************************************************/

VDEntity::VDEntity() {
    (void) strcpy_s(name, "");
    currentLocationX = 0;
    currentLocationY = 0;
    (void) strcpy_s(imageFileLocation, "");
};



/* **********************************************************************************************************************
   Destructor
   **********************************************************************************************************************/

VDEntity::~VDEntity() {
};



/* **********************************************************************************************************************
   Move
   ----
   Moves the entity in the specified direction.
   #param  direction  The direction in which to move (1 left, 2 right, 3 up, 4 down)
   **********************************************************************************************************************/

void VDEntity::Move(int direction) {
    switch (direction) {
        case 1:
            currentLocationX -= 1;
            break;
        case 2:
            currentLocationX += 1;
            break;
        case 3:
            currentLocationY -= 1;
            break;
        case 4:
            currentLocationY += 1;
            break;
        default:
            break;
    };
};



/* **********************************************************************************************************************
   Accessors and Modifiers
   **********************************************************************************************************************/

LPCTSTR VDEntity::GetName() {
    return name;
};

int VDEntity::GetCurrentLocationX() {
    return currentLocationX;
};

int VDEntity::GetCurrentLocationY() {
    return currentLocationY;
};

void VDEntity::SetCurrentLocation(int x, int y) {
    currentLocationX = x;
    currentLocationY = y;
};

LPSTR VDEntity::GetImageFileLocation() {
    return imageFileLocation;
};

void VDEntity::SetImageFileLocation(LPCSTR theImageFileLocation) {
    (void) strcpy_s(imageFileLocation, theImageFileLocation);
};