#ifndef VDNPCEDITOR_H
#define VDNPCEDITOR_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <windows.h>
#include <vector>
#include "VDNPC.h"
#include "VDSprite.h"
#include "VDError.h"
#include "Resource.h"
using namespace std;



/* **********************************************************************************************************************
   VDNPCEditor
   **********************************************************************************************************************/

class VDNPCEditor {
public:
    VDNPCEditor();
    ~VDNPCEditor();

      HWND CreateNPCEditor(HINSTANCE instance, LPCSTR className, list<VDNPC> npcList);

         HWND GetWindow();
         HWND GetNPCListBox();
         HWND GetNameEditBox();
         HWND GetLoadSpriteButton();
    VDSprite* GetNPCSprite();
         void SetNPCSprite(VDSprite *newSprite);
       LPCSTR GetNPCSpriteLocation();
         void SetNPCSpriteLocation(LPCSTR spriteLocation);
       LPRECT GetNPCSpriteDimensions(LPRECT outRect);
         HWND GetRemoveNPCButton();
         HWND GetSaveNPCButton();
         HWND GetDialogueListBox();
         HWND GetTextEditBox();
         HWND GetTextIDEditBox();
         HWND GetRemoveTextButton();
         HWND GetSaveTextButton();
private:
          HWND window;
          HWND npcListBox;
          HWND nameEditBox;
          HWND loadSpriteButton;
     VDSprite* npcSprite;
          char npcSpriteLocation[FILE_NAME_MAX_SIZE];
          RECT npcSpriteDimensions;
          HWND removeNPCButton;
          HWND saveNPCButton;
          HWND dialogueListBox;
          HWND textEditBox;
          HWND textIDEditBox;
          HWND removeTextButton;
          HWND saveTextButton;
};



#endif  // VDNPCEDITOR_H