#ifndef VDWORLD_H
#define VDWORLD_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include "VDTile.h"
#include "VDNPC.h"



/* **********************************************************************************************************************
   VDWorld
   **********************************************************************************************************************/

class VDWorld {
public:
    VDWorld();
    ~VDWorld();

            void CreateWorld(LPCSTR fileName);
            void LoadWorld(LPCSTR fileName);
            void WriteNPCs(LPCSTR fileName);
            void LoadNPCs(LPCSTR fileName);
             int ReallocateWorld(int worldMouseLocationX, int worldMouseLocationY);
             int CheckNewLocation(int direction, int entityLocationX, int entityLocationY);
             int AddNPC(LPCSTR name, LPCSTR imageFileLocation);
            void RemoveNPC(LPCSTR name);
             int AddNPCDialogue(LPCSTR npcName, int id, LPCSTR text);
            void RemoveNPCDialogue(LPCSTR name, int id);
          LPCSTR GetNPCDialogueText(LPCSTR name, int index);
          LPCSTR GetNPCDialogueTextFromID(LPCSTR name, int index);
    unsigned int GetNPCDialogueTextID(LPCSTR npcName, int index);

         VDTile GetTile(int x, int y);
        LPCTSTR GetTileImageFileLocation(int x, int y);
           void SetTileStatus(int x, int y, int theStatus);
           void SetTileImageFileLocation(int x, int y, LPCSTR theImageFileLocation);
           void SetTileSpawns(int x, int y, list<VDSpawn> theSpawns);
            int GetWorldSizeX();
            int GetWorldSizeY(); 
    list<VDNPC> GetNPCs();
          VDNPC GetNPC(LPCSTR name);
private:
    enum Status {
        NA,
        OPEN,
        BLOCKED,
        NEWAREA
    };

       VDTile** world;
            int worldSizeX;
            int worldSizeY;
    list<VDNPC> npcs;
};



#endif